discussion/discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

discussion/todolist/urls.py
from django.urls import path
# import the views.py from the same folder
from . import views


app_name = 'todolist'

urlpatterns = [
	path('index', views.index, name = 'index'),
	path('<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),
	path('events/<int:events_id>/', views.eventitem, name = "vieweventitem"),
	path('register', views.register, name = "register"),
	path('change_password', views.change_password, name = "change_password"),
	path('login', views.login_user, name = "login"),
	path('logout', views.logout_user, name = "logout"),
	path('add_task', views.add_task, name = "add_task"),
	path('add_event', views.add_event, name = "add_event"),
	path('<int:todoitem_id>/update_task', views.update_task, name="update_task"),
	path('<int:todoitem_id>/delete', views.delete_task, name = "delete_task")
]

discussion/todolist/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField('date created')
	user= models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

class Events(models.Model):
	event_name = models.CharField(max_length = 50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	event_date = models.DateTimeField('date created')
	user = models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

discussion/todolist/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm

class LoginForm(forms.Form):
	username = forms.CharField(label = "username", max_length = 20)
	password = forms.CharField(label = "password", max_length = 20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label = 'task_name', max_length =50)
	description = forms.CharField(label = 'description', max_length = 200)

class UpdateTaskForm(forms.Form):
	task_name = forms.CharField(label = "task_name", max_length = 50 )
	description = forms.CharField(label = "description", max_length = 200)
	status =  forms.CharField(label = "status", max_length =50)


class RegisterForm(UserCreationForm):
    class Meta:
        model=User
        fields = ['username','email','first_name','last_name','password1','password2'] 

class AddEventForm(forms.Form):
	event_name = forms.CharField(label = 'event_name', max_length =50)
	description = forms.CharField(label = 'description', max_length = 200)


class UpdateProfileForm(forms.ModelForm):
    username = forms.CharField(max_length=20,
                               required=True,
                               widget=forms.TextInput(attrs={'class': 'form-control'}))
    email = forms.EmailField(required=True,
                             widget=forms.TextInput(attrs={'class': 'form-control'}))
    password1 = forms.CharField(max_length=20,
                               required=True,
                               widget=forms.TextInput(attrs={'class': 'form-control'}))
    class Meta:
        model = User
        fields = ['first_name', 'last_name','password1']	        	

discussion/todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.

# The from keyword allows importing of necessary classes/modules, methods and others files needed in our application from the django.http package while the import keyword defines what we are importing from the package
from django.http import HttpResponse

# Local imports
from .models import ToDoItem
from .models import Events

# import the built in User Model
from django.contrib.auth.models import User

# to use the template created:
# from django.template import loader

# import the authenticate function
from django.contrib.auth import authenticate, login, logout

from django.forms.models import model_to_dict

from django.contrib import messages

from .forms import LoginForm, AddTaskForm, UpdateTaskForm,RegisterForm,AddEventForm,UpdateProfileForm

from django.utils import timezone

def index(request):
	todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
	event_list = Events.objects.filter(user_id = request.user.id)
	# template = loader.get_template("index.html")
	context = {
		'todoitem_list': todoitem_list,
		'event_list':event_list,
		"user": request.user
	}
	# output = ", ".join([todoitem.task_name for todoitem in todoitem_list])
	# render(request, route_template, context)
	return render(request, "index.html", context)

def todoitem(request, todoitem_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	todoitem = get_object_or_404(ToDoItem, pk = todoitem_id)

	return render(request, "todoitem.html", model_to_dict(todoitem))


def eventitem(request, events_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	eventitem_list = Events.objects.filter(user_id = request.user.id)
	eventitem = get_object_or_404(Events, pk = events_id)

	return render(request, "eventitem.html", model_to_dict(eventitem))	



# this function is responsible for registering on our application
def register(request):
    if request.method == 'GET':
        form = RegisterForm()
        return render(request, 'register.html', {'form': form})    
   
    if request.method == 'POST':
        form = RegisterForm(request.POST) 
        if form.is_valid():
            user = form.save(commit=False)
            user.username = user.username.lower()
            user.save()
            messages.success(request, 'You have singed up successfully.')
            login(request, user)
            return redirect("todolist:index")
        else:
            return render(request, 'register.html', {'form': form})	
	



	# users = User.objects.all()
	# is_user_registered = False

	# user = User()
	# user.username = "janedoe"
	# user.first_name = "jane"
	# user.last_name = "doe"
	# user.email = "jane@mail.com"
	# user.set_password("jane1234")
	# user.is_staff = False
	# user.is_active = True

	# for indiv_user in users:
	# 	if indiv_user.username == user.username:
	# 		is_user_registered = True
	# 		break

	# if is_user_registered == False:
	# 	# to save our user
	# 	user.save()

	# context = {
	# 	'is_user_registered': is_user_registered,
	# 	'first_name': user.first_name,
	# 	'last_name': user.last_name
	# }

	# return render(request, "register.html", context)



def change_password(request):
	is_user_authenticated = False

	updateuser = User.objects.filter(pk = User.id)

	context = {
		'user':request.user,
		'user_id': user_id,
		'first_name': first_name,
		'last_name': last_name,
		'password1': password1
	}
	if request.method == "POST":
		form = UpdateProfileForm(request.POST)

		if form.is_valid() == False:
			form = UpdateProfileForm()

		else:
			first_name = form.cleaned_data['first_name']
			last_name = form.cleaned_data['last_name']
			password1 = form.cleaned_data['password1']

			if updateuser:

				first_name = first_name
				last_name = last_name
				password1 = password1

				updateuser.save()

				return redirect("todolist:index")
			else:
				
				context = {
					"error": True
				}
	return render(request,"change_password.html",context)
	

def login_user(request):
	context = {}

	# if this is a post request we need to process the form data
	if request.method == "POST":

		form = LoginForm(request.POST)

		if form.is_valid() == False:
			form = LoginForm()
			
		else:
			print(form)
			# cleaned_data retrieves the information from the form
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']

			user = authenticate(username = username, password = password)

			if user is not None:
				context = {
					'username' : username,
					'password' : password
				}
				login(request, user)
				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}
			
	
	return render(request, "login.html", context)








	# username = 'johndoe'
	# password = 'johndoe1234567'

	# user = authenticate(username = username, password = password)

	

def logout_user(request):
	logout(request)
	return redirect("todolist:index")


def add_task(request):
	context = {}

	if request.method == 'POST':
		form = AddTaskForm(request.POST)

		if form.is_valid() == False:
			form = AddTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']

			duplicates = ToDoItem.objects.filter(task_name = task_name, user_id = request.user.id)

			if not duplicates:
				# create an ovbject based on the ToDoItem model and saves to the record in the database

				ToDoItem.objects.create(task_name = task_name, description = description, date_created = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}

	return render(request, "add_task.html", context)


def update_task(request, todoitem_id):

	todoitem = ToDoItem.objects.filter(pk = todoitem_id)
	print(todoitem)
	context = {
		"user": request.user,
		"todoitem_id": todoitem_id,
		"task_name": todoitem[0].task_name,
		"description": todoitem[0].description,
		"status" : todoitem[0].status
	}

	if request.method == "POST":
		form  = UpdateTaskForm (request.POST)

		if form.is_valid() == False:
			form = UpdateTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if todoitem:

				todoitem[0].task_name = task_name
				todoitem[0].description = description
				todoitem[0].status = status

				todoitem[0].save()

				return redirect("todolist:viewtodoitem", todoitem_id =  todoitem[0].id)
			else:

				context = {
					"error" : True
				}

	return render(request, "update_task.html", context)

def delete_task(request, todoitem_id):

	ToDoItem.objects.filter(pk = todoitem_id).delete()

	return redirect("todolist:index")











def add_event(request):
	context = {}

	if request.method == 'POST':
		form = AddEventForm(request.POST)

		if form.is_valid() == False:
			form = AddEventForm()

		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']

			duplicates = Events.objects.filter(event_name = event_name, user_id = request.user.id)

			if not duplicates:
				# create an ovbject based on the ToDoItem model and saves to the record in the database

				Events.objects.create(event_name = event_name, description = description, event_date = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}

	return render(request, "add_event.html", context)

discussion/todolist/templates/add_event.html
{% extends 'base.html' %}

{% block title %}Add Event{% endblock %}

{% block content %}
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">
				{% if error == True %}
					<p class = "text-danger">Event Already Exist!</p>
				{% endif %}
				<form action="{% url 'todolist:add_event' %}" method="POST">
					
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Event Name: </label>
					    <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>


{% endblock %}

discussion/todolist/templates/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">
				{% if error == True %}
					<p class = "text-danger">Duplicate Task Found!</p>
				{% endif %}
				<form action="{% url 'todolist:add_task' %}" method="POST">
					
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Task Name: </label>
					    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>


{% endblock %}

discussion/todolist/templates/change_password.html
{% extends "users/base.html" %}
{% block title %}Profile Page{% endblock title %}
{% block content %}
    <div class="row my-3 p-3">
        <img class="rounded-circle account-img" src="{{ user.profile.avatar.url }} " style="cursor: pointer;"/>
    </div>
    {% if user_form.errors %}
        <div class="alert alert-danger alert-dismissible" role="alert">
            <div id="form_errors">
                {% for key, value in user_form.errors.items %}
                    <strong>{{ value }}</strong>
                {% endfor %}
            </div>
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    {% endif %}
    <div class="form-content">
        <form method="post" enctype="multipart/form-data">
            {% csrf_token %}
            <div class="form-row">
                <div class="col-md-5">
                    <div class="form-group">
                        <label class="small mb-1">Username:</label>
                            {{ user_form.username }}
                        <label class="small mb-1">Email:</label>
                            {{ user_form.email }}
                    </div>
                    <div class="form-group">
                        <a href="#">Change Password</a>
                        <hr>    
                    </div>
                    
                </div>
            </div>
            <br><br>
            <button type="submit" class="btn btn-dark btn-lg">Save Changes</button>
            <button type="reset" class="btn btn-dark btn-lg">Reset</button>
        </form>
    </div>
{% endblock content %}

discussion/todolist/templates/eventitem.html
{% extends "base.html" %}

{% block title %}My Events{% endblock %}

{% block content %}
	<div class = "text-center mt-3">
		<h1>{{event_name}}</h1>

		<h3>Description:</h3>
		<p>{{description}}</p>


		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to index page!</a>
		</button>

	</div>
	

{% endblock %}

discussion/todolist/templates/index.html
{% extends 'base.html' %}

{%block title%}Home{% endblock %}

{% block content %}
	{% if todoitem_list and user.is_anonymous == False %}
		<h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>

		<div class = "container">
			<div class = 'row'>
				<h3 class = "text-center mb-3">My Tasks</h3>
				<ul class = " list-group text-center col-lg-4 offset-lg-4">
				{% for todoitem in todoitem_list %}
					<li class = "list-group-item"><a class = "text-decoration-none"href = "{% url 'todolist:viewtodoitem' todoitem.id %}">{{todoitem.task_name}}</a></li>
				{% endfor%}	
				</ul>
			</div>
		</div>

		
	{% elif todoitem_list.count == 0 and user.is_anonymous == False %}
		<h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
		<p class = "text-center my-3">No tasks have been created.</p>
	{%else%}
		<h1 class = "text-center my-3">You are not authorized to access this page.</h1>
		<p class = "text-center my-3">Kindly login <a href = "{% url 'todolist:login' %}">here</a>.</p>
	{% endif %}
	

	{% if event_list and user.is_anonymous == False %}
		<h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>

		<div class = "container">
			<div class = 'row'>
				<h3 class = "text-center mb-3">My Events</h3>
				<ul class = " list-group text-center col-lg-4 offset-lg-4">
				{% for eventitem in event_list %}
					<li class = "list-group-item"><a class = "text-decoration-none"href = "{% url 'todolist:vieweventitem' eventitem.id %}">{{eventitem.event_name}}</a></li>
				{% endfor%}	
				</ul>
			</div>
		</div>

		
	{% elif event_list.count == 0 and user.is_anonymous == False %}
		<h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
		<p class = "text-center my-3">No Events have been Planned!.</p>
	{%else%}
		<h1 class = "text-center my-3">You are not authorized to access this page.</h1>
		<p class = "text-center my-3">Kindly login <a href = "{% url 'todolist:login' %}">here</a>.</p>
	{% endif %}

{% endblock %}

discussion/todolist/templates/login.html
{% extends "base.html" %}

{% block title %}Login{% endblock %}

{% block content %}
	<h1 class = "text-center my-3">Login Form</h1>
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">

				{% if error == True %}
					<p class = "text-danger">Invalid credentials, please check your username and password or register first</p>
				{% endif %}
				
				<form action = "{% url 'todolist:login' %}" method = "POST">
					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains link, a from button or some javascript that is intended to perform some action in our website -->
					{% csrf_token %}
				  <div class="mb-3">
				    <label for="username" class="form-label">Username:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="username" 
				    	value = "{{ username }}"
				    	name = "username"
				    	maxlength = "20"
				    	required 
				    	>
				  </div>
				  <div class="mb-3">
				    <label for="password" class="form-label">Password:</label>
				    <input 
				    	type="password" 
				    	class="form-control" 
				    	id="password"
				    	name = "password"
				    	value = "{{ password }}"
				    	maxlength="20" 
				    	required
				    	>

				  </div>
				  
				  <button type="submit" class="btn btn-primary">Login</button>
				</form>
				
			</div>
			
		</div>
	</div>

{% endblock %}

discussion/todolist/templates/register.html
{% extends 'base.html' %}

{% block content %}
<form method="POST" novalidate>
	{% csrf_token %}
	<h2>Sign Up</h2>
		
	{% for field in form %}
	<p>
		{% if field.errors %}
		<ul class="errorlist">
			{% for error in field.errors %}
			<li>{{ error }}</li>
			{% endfor %}
		</ul>
		{% endif %}
	 	{{ field.label_tag }} {{ field }}
	</p>
	{% endfor %}
	<input type="submit" value="Register" />
</form>
{% endblock content%}

discussion/todolist/templates/todoitem.html
{% extends "base.html" %}

{% block title %}My Tasks{% endblock %}

{% block content %}
	<div class = "text-center mt-3">
		<h1>{{task_name}}</h1>

		<h3>Description:</h3>
		<p>{{description}}</p>

		<h3>Status:</h3>
		<p>{{status}}</p>

		<button class = "btn btn-success mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:update_task' id%}">Edit this task</a>
		</button>

		<button class = "btn btn-danger mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:delete_task' id %}">Delete this task</a>
		</button>

		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to index page!</a>
		</button>

	</div>
	

{% endblock %}

discussion/todolist/templates/update_task.html
{% extends "base.html" %}

{% block title %}Update Task{% endblock %}

{% block content %}
	{% if user.is_anonymous == False %}
		<div class = "container">
			<div class = "row">
				<div class = "col-6 offset-3">
					<h1 class = "text-center mt-3">Update Task</h1>

					{% if error == True %}
						<p class = "text-danger text-center">Task not found</p>
					{% endif %}
					<form action="{% url 'todolist:update_task' todoitem_id %}" method="POST">
						{% csrf_token %}

						<div class="mb-3">
						    <label for="task_name">Task Name: </label>
						    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
						</div>

						<div class="mb-3">
						    <label for="description">Description: </label>
						    <textarea class="form-control" name="description" required>{{ description }}</textarea>
						</div>

						<div class="mb-3">
						    <label for="status">Status: </label>
						    <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
						</div>

						<div class="text-center">
					    	<input class="btn btn-success" type="submit" value="Update Task">
						</div>

					</form>
				</div>
				
			</div>
		</div>
	{% endif %}

{% endblock %}